<script lang="ts" setup>
import { ref, onMounted, onBeforeUnmount, nextTick } from 'vue';
import { debounce } from 'lodash-es';
import NavigationCard from './NavigationCard.vue';
import NavigationDropdownFooter from './NavigationDropdownFooter.vue';
import NavigationDropdownList from './NavigationDropdownList.vue';
import ChevronIcon from '~/assets/icons/chevron.vue';
import type { MainNavigationLevelOneItems } from '@/types/navigation';

// Props
defineProps<{
  itemData: MainNavigationLevelOneItems;
  showDropdown: boolean;
}>();

// Refs
const resizeDebounce = ref(null);
const popover = ref(null);

// Methods
const resetOffset = () => {
  const classList = popover.value.classList;

  if (classList.value.includes('left')) {
    popover.value.style.left = `0`;
  } else if (classList.value.includes('right')) {
    popover.value.style.left = `70px`;
  } else {
    popover.value.style.left = `50%`;
  }
};

const calculateBoundaries = () => {
  resetOffset();
  const bodyRect = document.body.getBoundingClientRect();
  const rect = popover.value.getBoundingClientRect();
  const offset = bodyRect.right - rect.right;

  if (offset < 0) {
    popover.value.style.left = `${offset - 8}px`;
  }
};

// Lifecycle hooks
onMounted(() => {
  resizeDebounce.value = debounce(calculateBoundaries, 18);
  nextTick(() => {
    calculateBoundaries();
    window.addEventListener('resize', resizeDebounce.value);
  });
});

onBeforeUnmount(() => {
  window.removeEventListener('resize', resizeDebounce.value);
});
</script>

<template>
  <div class="navigation-dropdown">
    <SlpButton
      class="navigation-dropdown__button"
      variant="ghost"
      :href="itemData.config?.href"
      :data-ga-name="itemData.config.dataGaName"
      :data-ga-location="itemData.config.dataGaLocation"
      :data-nav-levelone="itemData.config.dataNavLevelOne"
      :title="itemData.text"
      :name="itemData.text"
    >
      <slot name="buttonContent">
        {{ itemData.text }}
      </slot>
      <ChevronIcon v-if="itemData.cards || itemData.lists" direction="down" />
    </SlpButton>
    <!-- The v-show directive needs to be used for the popover because we need to have
          all HTML elements in the DOM at all time for SEO purposes -->

    <div
      v-show="itemData.cards || itemData.lists"
      ref="popover"
      class="navigation-dropdown__popover navigation-dropdown__popover--hidden navigation-dropdown__popover--center"
      :class="[
        { 'navigation-dropdown__popover--left': itemData.cards || itemData.feature || itemData.left },
        { 'navigation-dropdown__popover--show': showDropdown },
      ]"
    >
      <div v-if="itemData.cards" class="navigation-dropdown__cards">
        <NavigationCard
          v-for="card in itemData.cards"
          v-bind="{ ...card, ...itemData.config }"
          :key="card.title"
        ></NavigationCard>
      </div>

      <NavigationDropdownList
        v-if="itemData.lists"
        v-bind="itemData"
        :class="{ 'navigation-dropdown-list--w-footer': itemData.footer }"
      ></NavigationDropdownList>

      <NavigationDropdownFooter v-if="itemData.footer" v-bind="{ ...itemData.footer, ...itemData.config }" />
    </div>
  </div>
</template>

<style lang="scss" scoped>
$popover-width: 170px;

.navigation-dropdown {
  position: relative;
  display: inline-block;
  padding-bottom: $spacing-16;
  margin-bottom: -$spacing-16;

  &:hover &__popover {
    visibility: visible;
    opacity: 1;
  }

  &:hover &__button {
    color: $color-text-300;

    svg {
      display: block;
    }
  }

  &__button {
    position: relative;
    color: $color-text-200;
    transition: all 0.3s ease-in-out;

    &:hover {
      color: $color-text-300;

      svg {
        display: block;
      }
    }

    svg {
      display: none;
      position: absolute;
      bottom: -4px;
      left: calc(50% - 8px);
    }
  }

  &__popover {
    top: 50px;
    position: absolute;
    min-width: $popover-width;
    background-color: white;
    z-index: 1;
    border: 1px solid $color-surface-300;
    border-radius: 4px;
    box-shadow: 0 8px 50px -16px rgba(209, 208, 211, 0.5);
    transition:
      visibility 0s,
      opacity 0.15s ease-in-out;
    display: flex;
    flex-wrap: wrap;

    &--center {
      transform: translateX(-50%);
      left: 50%;
    }

    &--hidden {
      visibility: hidden;
      opacity: 0;
    }

    &--left {
      transform: translateX(0);
      left: 0;
    }

    &--right {
      transform: translateX(-100%);
      left: 70px;
    }

    &--show {
      visibility: visible;
      opacity: 1;
    }
  }

  &__categories {
    display: flex;
    flex-direction: column;
    margin: 0 $spacing-4;
    min-width: $popover-width;
    break-inside: avoid;

    @media (min-width: $breakpoint-xl) {
      margin: 0 $spacing-16;
    }

    &--mb {
      margin-bottom: $spacing-24 !important;
    }
  }

  &__popover-link {
    padding: $spacing-8 0;
    color: $color-text-300 !important;
    white-space: nowrap;

    &:hover {
      color: $color-text-link-100 !important;
    }
  }

  &__bottom-link {
    padding-left: $spacing-8 !important;
    padding-bottom: 0 !important;
    transition: none !important;

    @media (min-width: $breakpoint-xl) {
      padding-left: $spacing-16 !important;
      padding-bottom: $spacing-16 !important;
    }
  }

  &__main {
    padding: $spacing-24 $spacing-16;
    display: flex;
    flex-direction: column;
    justify-content: space-between;

    @media (min-width: $breakpoint-xl) {
      padding: $spacing-24 $spacing-8;
    }

    &--w-columns {
      @media (max-width: $breakpoint-2xl) {
        margin-right: -50px;
      }
      @media (max-width: $breakpoint-xl) {
        margin-right: -80px;
      }
    }
  }

  &__side-section {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    padding: $spacing-24;
    background-color: $color-surface-800;
    white-space: normal;

    h5,
    p {
      color: $color-text-300;
    }

    &:hover {
      background-color: $color-surface-950;
      transition: all 0.3s ease-in-out;
    }
  }

  &__image,
  &__logo {
    max-width: 200px;
    margin-bottom: $spacing-16;
    width: 200px;
    height: 160px;

    @media (min-width: $breakpoint-xl) {
      width: 239px;
      max-width: 239px;
    }
  }

  &__logo {
    border-radius: $border-radius-4 $border-radius-4 50px $border-radius-4;
    background: $color-surface-50;
    padding: 12px;
    box-sizing: border-box;

    img {
      object-fit: contain;
    }
  }

  &__icon {
    max-width: 200px;
    margin-bottom: $spacing-16;
    width: 200px;

    @media (min-width: $breakpoint-xl) {
      width: 239px;
      max-width: 239px;
    }

    img {
      border-bottom-right-radius: 50px;
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }

  &__side-link {
    padding-left: 0 !important;
    padding-bottom: 0 !important;
    transition: none !important;
    text-align: left !important;

    & > * {
      transition: none !important;
    }

    &-small {
      font-size: 14px !important;
    }
  }

  &__footer {
    background-color: $color-surface-800;
    padding: $spacing-24 $spacing-32 $spacing-32 $spacing-32;
  }
  &__cards {
    @media (min-width: $breakpoint-lg) {
      display: flex;
      padding: 24px 8px;
    }
  }
}
.nav-card-grid {
  display: grid;
  grid-template-columns: repeat(3, 300px);
  gap: 1px;
  &.separators {
    background-color: $color-surface-200;
  }
}
.with-footer {
  display: flex;
  flex-direction: column;
}
.navigation-dropdown-list--w-footer {
  @media (min-width: $breakpoint-lg) {
    padding: 0 16px;
  }
  .navigation-dropdown-list__wrapper {
    @media (min-width: $breakpoint-lg) {
      padding: 24px 8px;
    }
  }
  .navigation-dropdown-list__section {
    margin-top: 8px;
  }
  .navigation-dropdown-list__item {
    padding: 12px 0 !important;
  }
  .navigation-dropdown-list__section {
    gap: 10px;
  }
  .navigation-dropdown-list__bottom-link {
    font-size: 16px;
    padding: 16px 0 0 0 !important;
    margin-top: 20px;
    .slp-icon {
      height: 12px;
      width: 12px;
      position: relative;
      svg {
        position: absolute;
        top: 0;
        left: 0;
      }
    }
  }
}
</style>
